#TEMPLATE(SQLAN, 'Server Bases Auto Increment Template Set'),FAMILY('ABC')
#!
#!
#! This is a re-work of Surf's SAIFile for Sybase SA Anywhere
#! by Jim Kane 9/30/99 for autonumbering an MSSQL Database
#!
#EXTENSION(SQL_AN1, 'Server Bases Auto Increment Global Extension'),APPLICATION
 #BOXED('SET UP Instructions')
 #display('Create MSSQL File Dummy with one field.')
 #display('Field called dummy_col of type int.')
 #display('Each SQL File - auto number in CW Dict.')
 #display('Identity field in SQL definition.')
 #display('Add two new Method Prototypes to ABFILE.INC')
 #display('Add code for two Methods to ABFILE.CLW')
 #display('Fix RestoreFile Code - Add Error Checking for ReSET.')
 #Display('   Jim Kane, Team TopSpeed, 9/30/99')
 #EndBoxed
#!
#!
#!
#AT(%CustomGlobalDeclarations)
#For(%File)
 #IF(%SQLANRequired())
   #Context(%Program)
   #SET(%OverrideUseDefaultFileManager,0)
   #SET(%OverrideFileManagerClass,'SQLAN')
   #! #Error(%OverrideFileManagerClass)
   #EndContext
 #ENDIF
#EndFor
#EndAt
#AT(%GlobalData),WHERE(%MSSQLFound())
AutoIncFile          FILE,DRIVER('MSSQL'),NAME('dummy')
Record                 RECORD
IncFld                   LONG,NAME('dummy_col')
                       END
                     END

AutoIncFileManager   CLASS(FileManager),type
FileOpen               BYTE
Init                   PROCEDURE(ErrorClass EC)
TryGetAutoIncValue     PROCEDURE(ANY),BYTE
                     END

Access:AutoIncFile   AutoIncFileManager
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'Open', '(),BYTE'),WHERE(%MSSQLFound()),PRIORITY(6000),DESCRIPTION('SQLANTpl')
  #IF(%SQLANRequired())
SELF.HasServerAutoInc = FALSE
    #FOR(%Key)
      #IF(%KeyAuto)
SELF.HasServerAutoInc = TRUE
SELF.AutoIncField &= %KeyAuto
SELF.AutoIncKey &= %key
        #BREAK
      #ENDIF
    #ENDFOR
  #ENDIF
#ENDAT
#!
#!
#AT(%FileManagerCodeSection, , 'TryGetAutoIncValue', '(),BYTE'),WHERE(%MSSQLFound()),PRIORITY(3000),DESCRIPTION('SQLANTpl')
  #IF(%SQLANRequired())
Access:AutoIncFile.Init(SELF.Errors)
If ~Access:AutoIncFile.TryGetAutoIncValue(SELF.AutoIncField)  then
    Get(SELF.FILE, SELF.AutoIncKey)
    If errorcode()
      SELF.SetError(Msg:AbortReading)
      Return Level:Notify       !get error
    end
else
  Return Level:Notify  !@@indentity error
end
Return Level:Benign
  #ENDIF
#ENDAT
#!
#!

#AT(%ProgramProcedures),WHERE(%MSSQLFound())


AutoIncFileManager.Init PROCEDURE(ErrorClass EC)
  CODE
    IF ~SELF.FileOpen
      PARENT.Init(AutoIncFile, EC)
      SELF.Buffer &= AutoIncFile.Record
      SELF.Create = 0
      SELF.LazyOpen = FALSE
      SELF.Open()
      SELF.FileOpen = TRUE
    END

AutoIncFileManager.TryGetAutoIncValue PROCEDURE(ANY AutoIncField)
  CODE
    SELF.File{PROP:SQL} = 'SELECT @@identity'
    IF ERRORCODE()
      SELF.SetError(Msg:AbortReading)
      RETURN Level:Notify
    END
    IF SELF.TryNext()
      RETURN Level:Notify
    END
    AutoIncField = AutoIncFile.IncFld
    RETURN Level:Benign
#ENDAT
#!
#!
#!
#!
#!
#GROUP(%MSSQLFound),PRESERVE
#FOR(%File)
  #IF(UPPER(%FileDriver) = 'MSSQL')
    #RETURN(%True)
  #ENDIF
#ENDFOR
#RETURN(%False)
#!
#!
#GROUP(%SetNULLS)
  #FOR(%Key)
    #IF(%KeyAuto)
SETNULL(%KeyAuto)
      #BREAK
    #ENDIF
  #ENDFOR
#!
#!
#GROUP(%SQLANRequired),PRESERVE
#IF(UPPER(%FileDriver) = 'MSSQL')
  #FOR(%Key)
    #IF(%KeyAuto)
      #RETURN(%True)
    #ENDIF
  #ENDFOR
#ENDIF
#RETURN(%False)
